GIT-WHATCHANGED(1)

NAME
git-whatchanged - Show logs with difference each commit introduces

SYNOPSIS

git whatchanged <option>...

DESCRIPTION

Shows commit logs and diff output each commit introduces. The command internally invokes git rev-list piped to git diff-tree, and takes command line options for both of these commands.

This manual page describes only the most frequently used options.

OPTIONS

-p
    Show textual diffs, instead of the git internal diff output format that is useful only to tell the changed paths and their nature of changes.

-<n>
    Limit output to <n> commits.

<since>..<until>
    Limit output to between the two named commits (bottom exclusive, top inclusive).

-r
    Show git internal diff output, but for the whole tree, not just the top level.

-m
    By default, differences for merge commits are not shown. With this flag, show differences to that commit from all of its parents.

    However, it is not very useful in general, although it is useful on a file-by-file basis.

--pretty[=<format>], --format[=<format>]
    Pretty-print the contents of the commit logs in a given format, where <format> can be one of oneline, short, medium, full, fuller, email, raw and format:<string>. When omitted, the format defaults to medium.

    Note: you can specify the default pretty format in the repository configuration (see git-config(1)).

--abbrev-commit
    Instead of showing the full 40-byte hexadecimal commit object name, show only a partial prefix. Non default number of digits can be specified with "--abbrev=<n>" (which also modifies diff output, if it is displayed).

    This should make "--pretty=oneline" a whole lot more readable for people using 80-column terminals.

--oneline
    This is a shorthand for "--pretty=oneline --abbrev-commit" used together.

--encoding[=<encoding>]
    The commit objects record the encoding used for the log message in their encoding header; this option can be used to tell the command to re-code the commit log message in the encoding preferred by the user. For non plumbing commands this defaults to UTF-8.

--no-notes, --show-notes
    Show the notes (see git-notes(1)) that annotate the commit, when showing the commit log message. This is the default for git log, git show and git whatchanged commands when there is no --pretty, --format nor --oneline option is given on the command line.

PRETTY FORMATS

If the commit is a merge, and if the pretty-format is not oneline, email or raw, an additional line is inserted before the Author: line. This line begins with "Merge: " and the sha1s of ancestral commits are printed, separated by spaces. Note that the listed commits may not necessarily be the list of the direct parent commits if you have limited your view of history: for example, if you are only interested in changes related to a certain directory or file.

Here are some additional details for each format:

    • oneline

        <sha1> <title line>

    This is designed to be as compact as possible.

    • short

        commit <sha1>
        Author: <author>

        <title line>

    • medium

        commit <sha1>
        Author: <author>
        Date:   <author date>

        <title line>

        <full commit message>

    • full

        commit <sha1>
        Author: <author>
        Commit: <committer>

        <title line>

        <full commit message>

    • fuller

        commit <sha1>
        Author:     <author>
        AuthorDate: <author date>
        Commit:     <committer>
        CommitDate: <committer date>

        <title line>

        <full commit message>

    • email

        From <sha1> <date>
        From: <author>
        Date: <author date>
        Subject: [PATCH] <title line>

        <full commit message>

    • raw

    The raw format shows the entire commit exactly as stored in the commit object. Notably, the SHA1s are displayed in full, regardless of whether --abbrev or --no-abbrev are used, and parents information show the true parent commits, without taking grafts nor history simplification into account.

    • format:

    The format: format allows you to specify which information you want to show. It works a little bit like printf format, with the notable exception that you get a newline with %n instead of \n.

    E.g, format:"The author of %h was %an, %ar%nThe title was >>%s<<%n" would show something like this:

        The author of fe6e0ee was Junio C Hamano, 23 hours ago
        The title was >>t4119: test autocomputing -p<n> for traditional diff input.<<

    The placeholders are:

        • %H: commit hash

        • %h: abbreviated commit hash

        • %T: tree hash

        • %t: abbreviated tree hash

        • %P: parent hashes

        • %p: abbreviated parent hashes

        • %an: author name

        • %aN: author name (respecting .mailmap, see git-shortlog(1) or git-blame(1))

        • %ae: author email

        • %aE: author email (respecting .mailmap, see git-shortlog(1) or git-blame(1))

        • %ad: author date (format respects --date= option)

        • %aD: author date, RFC2822 style

        • %ar: author date, relative

        • %at: author date, UNIX timestamp

        • %ai: author date, ISO 8601 format

        • %cn: committer name

        • %cN: committer name (respecting .mailmap, see git-shortlog(1) or git-blame(1))

        • %ce: committer email

        • %cE: committer email (respecting .mailmap, see git-shortlog(1) or git-blame(1))

        • %cd: committer date

        • %cD: committer date, RFC2822 style

        • %cr: committer date, relative

        • %ct: committer date, UNIX timestamp

        • %ci: committer date, ISO 8601 format

        • %d: ref names, like the --decorate option of git-log(1)

        • %e: encoding

        • %s: subject

        • %f: sanitized subject line, suitable for a filename

        • %b: body

        • %N: commit notes

        • %gD: reflog selector, e.g., refs/stash@{1}

        • %gd: shortened reflog selector, e.g., stash@{1}

        • %gs: reflog subject

        • %Cred: switch color to red

        • %Cgreen: switch color to green

        • %Cblue: switch color to blue

        • %Creset: reset color

        • %C(...): color specification, as described in color.branch.* config option

        • %m: left, right or boundary mark

        • %n: newline

        • %%: a raw %

        • %x00: print a byte from a hex code

        • %w([<w>[,<i1>[,<i2>]]]): switch line wrapping, like the -w option of git-shortlog(1).

    Note

    Some placeholders may depend on other options given to the revision traversal engine. For example, the %g* reflog options will insert an empty string unless we are traversing reflog entries (e.g., by git log -g). The %d placeholder will use the "short" decoration format if --decorate was not already provided on the command line.

If you add a + (plus sign) after % of a placeholder, a line-feed is inserted immediately before the expansion if and only if the placeholder expands to a non-empty string.

If you add a - (minus sign) after % of a placeholder, line-feeds that immediately precede the expansion are deleted if and only if the placeholder expands to an empty string.

    • tformat:

    The tformat: format works exactly like format:, except that it provides "terminator" semantics instead of "separator" semantics. In other words, each commit has the message terminator character (usually a newline) appended, rather than a separator placed between entries. This means that the final entry of a single-line format will be properly terminated with a new line, just as the "oneline" format does. For example:

        $ git log -2 --pretty=format:%h 4da45bef \
          | perl -pe '$_ .= " -- NO NEWLINE\n" unless /\n/'
        4da45be
        7134973 -- NO NEWLINE
        $ git log -2 --pretty=tformat:%h 4da45bef \
          | perl -pe '$_ .= " -- NO NEWLINE\n" unless /\n/'
        4da45be
        7134973

    In addition, any unrecognized string that has a % in it is interpreted as if it has tformat: in front of it. For example, these two are equivalent:

        $ git log -2 --pretty=tformat:%h 4da45bef
        $ git log -2 --pretty=%h 4da45bef

EXAMPLES

git whatchanged -p v2.6.12.. include/scsi drivers/scsi
    Show as patches the commits since version v2.6.12 that changed any file in the include/scsi or drivers/scsi subdirectories

git whatchanged --since="2 weeks ago" -- gitk
    Show the changes during the last two weeks to the file gitk. The "--" is necessary to avoid confusion with the branch named gitk

AUTHOR

Written by Linus Torvalds <torvalds@osdl.org> and Junio C Hamano <gitster@pobox.com>

DOCUMENTATION

Documentation by David Greaves, Junio C Hamano and the git-list <git@vger.kernel.org>.

GIT

Part of the git(1) suite